Loading...
1#!/bin/sh
2
3# Copyright (C) 2006 Paul Mackerras, IBM Corporation <paulus@samba.org>
4# This program may be used under the terms of version 2 of the GNU
5# General Public License.
6
7# This script takes a kernel binary and optionally an initrd image
8# and/or a device-tree blob, and creates a bootable zImage for a
9# given platform.
10
11# Options:
12# -o zImage specify output file
13# -p platform specify platform (links in $platform.o)
14# -i initrd specify initrd file
15# -d devtree specify device-tree blob
16# -s tree.dts specify device-tree source file (needs dtc installed)
17# -c cache $kernel.strip.gz (use if present & newer, else make)
18# -C prefix specify command prefix for cross-building tools
19# (strip, objcopy, ld)
20# -D dir specify directory containing data files used by script
21# (default ./arch/powerpc/boot)
22# -W dir specify working directory for temporary files (default .)
23
24# Stop execution if any command fails
25set -e
26
27# Allow for verbose output
28if [ "$V" = 1 ]; then
29 set -x
30fi
31
32# defaults
33kernel=
34ofile=zImage
35platform=of
36initrd=
37dtb=
38dts=
39cacheit=
40binary=
41gzip=.gz
42pie=
43
44# cross-compilation prefix
45CROSS=
46
47# mkimage wrapper script
48MKIMAGE=$srctree/scripts/mkuboot.sh
49
50# directory for object and other files used by this script
51object=arch/powerpc/boot
52objbin=$object
53dtc=scripts/dtc/dtc
54
55# directory for working files
56tmpdir=.
57
58usage() {
59 echo 'Usage: wrapper [-o output] [-p platform] [-i initrd]' >&2
60 echo ' [-d devtree] [-s tree.dts] [-c] [-C cross-prefix]' >&2
61 echo ' [-D datadir] [-W workingdir] [--no-gzip] [vmlinux]' >&2
62 exit 1
63}
64
65while [ "$#" -gt 0 ]; do
66 case "$1" in
67 -o)
68 shift
69 [ "$#" -gt 0 ] || usage
70 ofile="$1"
71 ;;
72 -p)
73 shift
74 [ "$#" -gt 0 ] || usage
75 platform="$1"
76 ;;
77 -i)
78 shift
79 [ "$#" -gt 0 ] || usage
80 initrd="$1"
81 ;;
82 -d)
83 shift
84 [ "$#" -gt 0 ] || usage
85 dtb="$1"
86 ;;
87 -s)
88 shift
89 [ "$#" -gt 0 ] || usage
90 dts="$1"
91 ;;
92 -c)
93 cacheit=y
94 ;;
95 -C)
96 shift
97 [ "$#" -gt 0 ] || usage
98 CROSS="$1"
99 ;;
100 -D)
101 shift
102 [ "$#" -gt 0 ] || usage
103 object="$1"
104 objbin="$1"
105 ;;
106 -W)
107 shift
108 [ "$#" -gt 0 ] || usage
109 tmpdir="$1"
110 ;;
111 --no-gzip)
112 gzip=
113 ;;
114 -?)
115 usage
116 ;;
117 *)
118 [ -z "$kernel" ] || usage
119 kernel="$1"
120 ;;
121 esac
122 shift
123done
124
125if [ -n "$dts" ]; then
126 if [ ! -r "$dts" -a -r "$object/dts/$dts" ]; then
127 dts="$object/dts/$dts"
128 fi
129 if [ -z "$dtb" ]; then
130 dtb="$platform.dtb"
131 fi
132 $dtc -O dtb -o "$dtb" -b 0 "$dts"
133fi
134
135if [ -z "$kernel" ]; then
136 kernel=vmlinux
137fi
138
139platformo=$object/"$platform".o
140lds=$object/zImage.lds
141ext=strip
142objflags=-S
143tmp=$tmpdir/zImage.$$.o
144ksection=.kernel:vmlinux.strip
145isection=.kernel:initrd
146link_address='0x400000'
147
148case "$platform" in
149pseries)
150 platformo=$object/of.o
151 link_address='0x4000000'
152 ;;
153maple)
154 platformo=$object/of.o
155 link_address='0x400000'
156 ;;
157pmac|chrp)
158 platformo=$object/of.o
159 ;;
160coff)
161 platformo="$object/crt0.o $object/of.o"
162 lds=$object/zImage.coff.lds
163 link_address='0x500000'
164 pie=
165 ;;
166miboot|uboot)
167 # miboot and U-boot want just the bare bits, not an ELF binary
168 ext=bin
169 objflags="-O binary"
170 tmp="$ofile"
171 ksection=image
172 isection=initrd
173 ;;
174cuboot*)
175 binary=y
176 gzip=
177 case "$platform" in
178 *-mpc866ads|*-mpc885ads|*-adder875*|*-ep88xc)
179 platformo=$object/cuboot-8xx.o
180 ;;
181 *5200*|*-motionpro)
182 platformo=$object/cuboot-52xx.o
183 ;;
184 *-pq2fads|*-ep8248e|*-mpc8272*|*-storcenter)
185 platformo=$object/cuboot-pq2.o
186 ;;
187 *-mpc824*)
188 platformo=$object/cuboot-824x.o
189 ;;
190 *-mpc83*|*-asp834x*)
191 platformo=$object/cuboot-83xx.o
192 ;;
193 *-tqm8541|*-mpc8560*|*-tqm8560|*-tqm8555|*-ksi8560*)
194 platformo=$object/cuboot-85xx-cpm2.o
195 ;;
196 *-mpc85*|*-tqm85*|*-sbc85*)
197 platformo=$object/cuboot-85xx.o
198 ;;
199 *-amigaone)
200 link_address='0x800000'
201 ;;
202 esac
203 ;;
204ps3)
205 platformo="$object/ps3-head.o $object/ps3-hvcall.o $object/ps3.o"
206 lds=$object/zImage.ps3.lds
207 gzip=
208 ext=bin
209 objflags="-O binary --set-section-flags=.bss=contents,alloc,load,data"
210 ksection=.kernel:vmlinux.bin
211 isection=.kernel:initrd
212 link_address=''
213 pie=
214 ;;
215ep88xc|ep405|ep8248e)
216 platformo="$object/fixed-head.o $object/$platform.o"
217 binary=y
218 ;;
219adder875-redboot)
220 platformo="$object/fixed-head.o $object/redboot-8xx.o"
221 binary=y
222 ;;
223simpleboot-virtex405-*)
224 platformo="$object/virtex405-head.o $object/simpleboot.o $object/virtex.o"
225 binary=y
226 ;;
227simpleboot-virtex440-*)
228 platformo="$object/fixed-head.o $object/simpleboot.o $object/virtex.o"
229 binary=y
230 ;;
231simpleboot-*)
232 platformo="$object/fixed-head.o $object/simpleboot.o"
233 binary=y
234 ;;
235asp834x-redboot)
236 platformo="$object/fixed-head.o $object/redboot-83xx.o"
237 binary=y
238 ;;
239xpedite52*)
240 link_address='0x1400000'
241 platformo=$object/cuboot-85xx.o
242 ;;
243gamecube|wii)
244 link_address='0x600000'
245 platformo="$object/$platform-head.o $object/$platform.o"
246 ;;
247treeboot-iss4xx-mpic)
248 platformo="$object/treeboot-iss4xx.o"
249 ;;
250epapr)
251 link_address='0x20000000'
252 pie=-pie
253 ;;
254esac
255
256vmz="$tmpdir/`basename \"$kernel\"`.$ext"
257if [ -z "$cacheit" -o ! -f "$vmz$gzip" -o "$vmz$gzip" -ot "$kernel" ]; then
258 ${CROSS}objcopy $objflags "$kernel" "$vmz.$$"
259
260 if [ -n "$gzip" ]; then
261 gzip -n -f -9 "$vmz.$$"
262 fi
263
264 if [ -n "$cacheit" ]; then
265 mv -f "$vmz.$$$gzip" "$vmz$gzip"
266 else
267 vmz="$vmz.$$"
268 fi
269fi
270
271vmz="$vmz$gzip"
272
273# Extract kernel version information, some platforms want to include
274# it in the image header
275version=`${CROSS}strings "$kernel" | grep '^Linux version [-0-9.]' | \
276 cut -d' ' -f3`
277if [ -n "$version" ]; then
278 uboot_version="-n Linux-$version"
279fi
280
281# physical offset of kernel image
282membase=`${CROSS}objdump -p "$kernel" | grep -m 1 LOAD | awk '{print $7}'`
283
284case "$platform" in
285uboot)
286 rm -f "$ofile"
287 ${MKIMAGE} -A ppc -O linux -T kernel -C gzip -a $membase -e $membase \
288 $uboot_version -d "$vmz" "$ofile"
289 if [ -z "$cacheit" ]; then
290 rm -f "$vmz"
291 fi
292 exit 0
293 ;;
294esac
295
296addsec() {
297 ${CROSS}objcopy $4 $1 \
298 --add-section=$3="$2" \
299 --set-section-flags=$3=contents,alloc,load,readonly,data
300}
301
302addsec $tmp "$vmz" $ksection $object/empty.o
303if [ -z "$cacheit" ]; then
304 rm -f "$vmz"
305fi
306
307if [ -n "$initrd" ]; then
308 addsec $tmp "$initrd" $isection
309fi
310
311if [ -n "$dtb" ]; then
312 addsec $tmp "$dtb" .kernel:dtb
313 if [ -n "$dts" ]; then
314 rm $dtb
315 fi
316fi
317
318if [ "$platform" != "miboot" ]; then
319 if [ -n "$link_address" ] ; then
320 text_start="-Ttext $link_address"
321 fi
322 ${CROSS}ld -m elf32ppc -T $lds $text_start $pie -o "$ofile" \
323 $platformo $tmp $object/wrapper.a
324 rm $tmp
325fi
326
327# Some platforms need the zImage's entry point and base address
328base=0x`${CROSS}nm "$ofile" | grep ' _start$' | cut -d' ' -f1`
329entry=`${CROSS}objdump -f "$ofile" | grep '^start address ' | cut -d' ' -f3`
330
331if [ -n "$binary" ]; then
332 mv "$ofile" "$ofile".elf
333 ${CROSS}objcopy -O binary "$ofile".elf "$ofile"
334fi
335
336# post-processing needed for some platforms
337case "$platform" in
338pseries|chrp|maple)
339 $objbin/addnote "$ofile"
340 ;;
341coff)
342 ${CROSS}objcopy -O aixcoff-rs6000 --set-start "$entry" "$ofile"
343 $objbin/hack-coff "$ofile"
344 ;;
345cuboot*)
346 gzip -n -f -9 "$ofile"
347 ${MKIMAGE} -A ppc -O linux -T kernel -C gzip -a "$base" -e "$entry" \
348 $uboot_version -d "$ofile".gz "$ofile"
349 ;;
350treeboot*)
351 mv "$ofile" "$ofile.elf"
352 $objbin/mktree "$ofile.elf" "$ofile" "$base" "$entry"
353 if [ -z "$cacheit" ]; then
354 rm -f "$ofile.elf"
355 fi
356 exit 0
357 ;;
358ps3)
359 # The ps3's loader supports loading a gzipped binary image from flash
360 # rom to ram addr zero. The loader then enters the system reset
361 # vector at addr 0x100. A bootwrapper overlay is used to arrange for
362 # a binary image of the kernel to be at addr zero, and yet have a
363 # suitable bootwrapper entry at 0x100. To construct the final rom
364 # image 512 bytes from offset 0x100 is copied to the bootwrapper
365 # place holder at symbol __system_reset_kernel. The 512 bytes of the
366 # bootwrapper entry code at symbol __system_reset_overlay is then
367 # copied to offset 0x100. At runtime the bootwrapper program copies
368 # the data at __system_reset_kernel back to addr 0x100.
369
370 system_reset_overlay=0x`${CROSS}nm "$ofile" \
371 | grep ' __system_reset_overlay$' \
372 | cut -d' ' -f1`
373 system_reset_overlay=`printf "%d" $system_reset_overlay`
374 system_reset_kernel=0x`${CROSS}nm "$ofile" \
375 | grep ' __system_reset_kernel$' \
376 | cut -d' ' -f1`
377 system_reset_kernel=`printf "%d" $system_reset_kernel`
378 overlay_dest="256"
379 overlay_size="512"
380
381 ${CROSS}objcopy -O binary "$ofile" "$ofile.bin"
382
383 dd if="$ofile.bin" of="$ofile.bin" conv=notrunc \
384 skip=$overlay_dest seek=$system_reset_kernel \
385 count=$overlay_size bs=1
386
387 dd if="$ofile.bin" of="$ofile.bin" conv=notrunc \
388 skip=$system_reset_overlay seek=$overlay_dest \
389 count=$overlay_size bs=1
390
391 odir="$(dirname "$ofile.bin")"
392 rm -f "$odir/otheros.bld"
393 gzip -n --force -9 --stdout "$ofile.bin" > "$odir/otheros.bld"
394 ;;
395esac
1#!/bin/sh
2
3# Copyright (C) 2006 Paul Mackerras, IBM Corporation <paulus@samba.org>
4# This program may be used under the terms of version 2 of the GNU
5# General Public License.
6
7# This script takes a kernel binary and optionally an initrd image
8# and/or a device-tree blob, and creates a bootable zImage for a
9# given platform.
10
11# Options:
12# -o zImage specify output file
13# -p platform specify platform (links in $platform.o)
14# -i initrd specify initrd file
15# -d devtree specify device-tree blob
16# -s tree.dts specify device-tree source file (needs dtc installed)
17# -c cache $kernel.strip.gz (use if present & newer, else make)
18# -C prefix specify command prefix for cross-building tools
19# (strip, objcopy, ld)
20# -D dir specify directory containing data files used by script
21# (default ./arch/powerpc/boot)
22# -W dir specify working directory for temporary files (default .)
23
24# Stop execution if any command fails
25set -e
26
27# Allow for verbose output
28if [ "$V" = 1 ]; then
29 set -x
30fi
31
32# defaults
33kernel=
34ofile=zImage
35platform=of
36initrd=
37dtb=
38dts=
39cacheit=
40binary=
41gzip=.gz
42pie=
43format=
44
45# cross-compilation prefix
46CROSS=
47
48# mkimage wrapper script
49MKIMAGE=$srctree/scripts/mkuboot.sh
50
51# directory for object and other files used by this script
52object=arch/powerpc/boot
53objbin=$object
54dtc=scripts/dtc/dtc
55
56# directory for working files
57tmpdir=.
58
59usage() {
60 echo 'Usage: wrapper [-o output] [-p platform] [-i initrd]' >&2
61 echo ' [-d devtree] [-s tree.dts] [-c] [-C cross-prefix]' >&2
62 echo ' [-D datadir] [-W workingdir] [--no-gzip] [vmlinux]' >&2
63 exit 1
64}
65
66run_cmd() {
67 if [ "$V" = 1 ]; then
68 $* 2>&1
69 else
70 local msg
71
72 set +e
73 msg=$($* 2>&1)
74
75 if [ $? -ne "0" ]; then
76 echo $msg
77 exit 1
78 fi
79 set -e
80 fi
81}
82
83while [ "$#" -gt 0 ]; do
84 case "$1" in
85 -o)
86 shift
87 [ "$#" -gt 0 ] || usage
88 ofile="$1"
89 ;;
90 -p)
91 shift
92 [ "$#" -gt 0 ] || usage
93 platform="$1"
94 ;;
95 -i)
96 shift
97 [ "$#" -gt 0 ] || usage
98 initrd="$1"
99 ;;
100 -d)
101 shift
102 [ "$#" -gt 0 ] || usage
103 dtb="$1"
104 ;;
105 -s)
106 shift
107 [ "$#" -gt 0 ] || usage
108 dts="$1"
109 ;;
110 -c)
111 cacheit=y
112 ;;
113 -C)
114 shift
115 [ "$#" -gt 0 ] || usage
116 CROSS="$1"
117 ;;
118 -D)
119 shift
120 [ "$#" -gt 0 ] || usage
121 object="$1"
122 objbin="$1"
123 ;;
124 -W)
125 shift
126 [ "$#" -gt 0 ] || usage
127 tmpdir="$1"
128 ;;
129 --no-gzip)
130 gzip=
131 ;;
132 -?)
133 usage
134 ;;
135 *)
136 [ -z "$kernel" ] || usage
137 kernel="$1"
138 ;;
139 esac
140 shift
141done
142
143if [ -n "$dts" ]; then
144 if [ ! -r "$dts" -a -r "$object/dts/$dts" ]; then
145 dts="$object/dts/$dts"
146 fi
147 if [ -z "$dtb" ]; then
148 dtb="$platform.dtb"
149 fi
150 $dtc -O dtb -o "$dtb" -b 0 "$dts"
151fi
152
153if [ -z "$kernel" ]; then
154 kernel=vmlinux
155fi
156
157LANG=C elfformat="`${CROSS}objdump -p "$kernel" | grep 'file format' | awk '{print $4}'`"
158case "$elfformat" in
159 elf64-powerpcle) format=elf64lppc ;;
160 elf64-powerpc) format=elf32ppc ;;
161 elf32-powerpc) format=elf32ppc ;;
162esac
163
164
165platformo=$object/"$platform".o
166lds=$object/zImage.lds
167ext=strip
168objflags=-S
169tmp=$tmpdir/zImage.$$.o
170ksection=.kernel:vmlinux.strip
171isection=.kernel:initrd
172link_address='0x400000'
173make_space=y
174
175case "$platform" in
176of)
177 platformo="$object/of.o $object/epapr.o"
178 make_space=n
179 ;;
180pseries)
181 platformo="$object/pseries-head.o $object/of.o $object/epapr.o"
182 link_address='0x4000000'
183 if [ "$format" != "elf32ppc" ]; then
184 link_address=
185 pie=-pie
186 fi
187 make_space=n
188 ;;
189maple)
190 platformo="$object/of.o $object/epapr.o"
191 link_address='0x400000'
192 make_space=n
193 ;;
194pmac|chrp)
195 platformo="$object/of.o $object/epapr.o"
196 make_space=n
197 ;;
198coff)
199 platformo="$object/crt0.o $object/of.o $object/epapr.o"
200 lds=$object/zImage.coff.lds
201 link_address='0x500000'
202 make_space=n
203 pie=
204 ;;
205miboot|uboot*)
206 # miboot and U-boot want just the bare bits, not an ELF binary
207 ext=bin
208 objflags="-O binary"
209 tmp="$ofile"
210 ksection=image
211 isection=initrd
212 ;;
213cuboot*)
214 binary=y
215 gzip=
216 case "$platform" in
217 *-mpc866ads|*-mpc885ads|*-adder875*|*-ep88xc)
218 platformo=$object/cuboot-8xx.o
219 ;;
220 *5200*|*-motionpro)
221 platformo=$object/cuboot-52xx.o
222 ;;
223 *-pq2fads|*-ep8248e|*-mpc8272*|*-storcenter)
224 platformo=$object/cuboot-pq2.o
225 ;;
226 *-mpc824*)
227 platformo=$object/cuboot-824x.o
228 ;;
229 *-mpc83*|*-asp834x*)
230 platformo=$object/cuboot-83xx.o
231 ;;
232 *-tqm8541|*-mpc8560*|*-tqm8560|*-tqm8555|*-ksi8560*)
233 platformo=$object/cuboot-85xx-cpm2.o
234 ;;
235 *-mpc85*|*-tqm85*|*-sbc85*)
236 platformo=$object/cuboot-85xx.o
237 ;;
238 *-amigaone)
239 link_address='0x800000'
240 ;;
241 esac
242 ;;
243ps3)
244 platformo="$object/ps3-head.o $object/ps3-hvcall.o $object/ps3.o"
245 lds=$object/zImage.ps3.lds
246 gzip=
247 ext=bin
248 objflags="-O binary --set-section-flags=.bss=contents,alloc,load,data"
249 ksection=.kernel:vmlinux.bin
250 isection=.kernel:initrd
251 link_address=''
252 make_space=n
253 pie=
254 ;;
255ep88xc|ep405|ep8248e)
256 platformo="$object/fixed-head.o $object/$platform.o"
257 binary=y
258 ;;
259adder875-redboot)
260 platformo="$object/fixed-head.o $object/redboot-8xx.o"
261 binary=y
262 ;;
263simpleboot-virtex405-*)
264 platformo="$object/virtex405-head.o $object/simpleboot.o $object/virtex.o"
265 binary=y
266 ;;
267simpleboot-virtex440-*)
268 platformo="$object/fixed-head.o $object/simpleboot.o $object/virtex.o"
269 binary=y
270 ;;
271simpleboot-*)
272 platformo="$object/fixed-head.o $object/simpleboot.o"
273 binary=y
274 ;;
275asp834x-redboot)
276 platformo="$object/fixed-head.o $object/redboot-83xx.o"
277 binary=y
278 ;;
279xpedite52*)
280 link_address='0x1400000'
281 platformo=$object/cuboot-85xx.o
282 ;;
283gamecube|wii)
284 link_address='0x600000'
285 platformo="$object/$platform-head.o $object/$platform.o"
286 ;;
287treeboot-currituck)
288 link_address='0x1000000'
289 ;;
290treeboot-akebono)
291 link_address='0x1000000'
292 ;;
293treeboot-iss4xx-mpic)
294 platformo="$object/treeboot-iss4xx.o"
295 ;;
296epapr)
297 platformo="$object/pseries-head.o $object/epapr.o $object/epapr-wrapper.o"
298 link_address='0x20000000'
299 pie=-pie
300 ;;
301mvme5100)
302 platformo="$object/fixed-head.o $object/mvme5100.o"
303 binary=y
304 ;;
305esac
306
307vmz="$tmpdir/`basename \"$kernel\"`.$ext"
308if [ -z "$cacheit" -o ! -f "$vmz$gzip" -o "$vmz$gzip" -ot "$kernel" ]; then
309 ${CROSS}objcopy $objflags "$kernel" "$vmz.$$"
310
311 strip_size=$(stat -c %s $vmz.$$)
312
313 if [ -n "$gzip" ]; then
314 gzip -n -f -9 "$vmz.$$"
315 fi
316
317 if [ -n "$cacheit" ]; then
318 mv -f "$vmz.$$$gzip" "$vmz$gzip"
319 else
320 vmz="$vmz.$$"
321 fi
322else
323 # Calculate the vmlinux.strip size
324 ${CROSS}objcopy $objflags "$kernel" "$vmz.$$"
325 strip_size=$(stat -c %s $vmz.$$)
326 rm -f $vmz.$$
327fi
328
329if [ "$make_space" = "y" ]; then
330 # Round the size to next higher MB limit
331 round_size=$(((strip_size + 0xfffff) & 0xfff00000))
332
333 round_size=0x$(printf "%x" $round_size)
334 link_addr=$(printf "%d" $link_address)
335
336 if [ $link_addr -lt $strip_size ]; then
337 echo "INFO: Uncompressed kernel (size 0x$(printf "%x\n" $strip_size))" \
338 "overlaps the address of the wrapper($link_address)"
339 echo "INFO: Fixing the link_address of wrapper to ($round_size)"
340 link_address=$round_size
341 fi
342fi
343
344vmz="$vmz$gzip"
345
346# Extract kernel version information, some platforms want to include
347# it in the image header
348version=`${CROSS}strings "$kernel" | grep '^Linux version [-0-9.]' | \
349 cut -d' ' -f3`
350if [ -n "$version" ]; then
351 uboot_version="-n Linux-$version"
352fi
353
354# physical offset of kernel image
355membase=`${CROSS}objdump -p "$kernel" | grep -m 1 LOAD | awk '{print $7}'`
356
357case "$platform" in
358uboot)
359 rm -f "$ofile"
360 ${MKIMAGE} -A ppc -O linux -T kernel -C gzip -a $membase -e $membase \
361 $uboot_version -d "$vmz" "$ofile"
362 if [ -z "$cacheit" ]; then
363 rm -f "$vmz"
364 fi
365 exit 0
366 ;;
367uboot-obs600)
368 rm -f "$ofile"
369 # obs600 wants a multi image with an initrd, so we need to put a fake
370 # one in even when building a "normal" image.
371 if [ -n "$initrd" ]; then
372 real_rd="$initrd"
373 else
374 real_rd=`mktemp`
375 echo "\0" >>"$real_rd"
376 fi
377 ${MKIMAGE} -A ppc -O linux -T multi -C gzip -a $membase -e $membase \
378 $uboot_version -d "$vmz":"$real_rd":"$dtb" "$ofile"
379 if [ -z "$initrd" ]; then
380 rm -f "$real_rd"
381 fi
382 if [ -z "$cacheit" ]; then
383 rm -f "$vmz"
384 fi
385 exit 0
386 ;;
387esac
388
389addsec() {
390 ${CROSS}objcopy $4 $1 \
391 --add-section=$3="$2" \
392 --set-section-flags=$3=contents,alloc,load,readonly,data
393}
394
395addsec $tmp "$vmz" $ksection $object/empty.o
396if [ -z "$cacheit" ]; then
397 rm -f "$vmz"
398fi
399
400if [ -n "$initrd" ]; then
401 addsec $tmp "$initrd" $isection
402fi
403
404if [ -n "$dtb" ]; then
405 addsec $tmp "$dtb" .kernel:dtb
406 if [ -n "$dts" ]; then
407 rm $dtb
408 fi
409fi
410
411if [ "$platform" != "miboot" ]; then
412 if [ -n "$link_address" ] ; then
413 text_start="-Ttext $link_address"
414 fi
415 ${CROSS}ld -m $format -T $lds $text_start $pie -o "$ofile" \
416 $platformo $tmp $object/wrapper.a
417 rm $tmp
418fi
419
420# Some platforms need the zImage's entry point and base address
421base=0x`${CROSS}nm "$ofile" | grep ' _start$' | cut -d' ' -f1`
422entry=`${CROSS}objdump -f "$ofile" | grep '^start address ' | cut -d' ' -f3`
423
424if [ -n "$binary" ]; then
425 mv "$ofile" "$ofile".elf
426 ${CROSS}objcopy -O binary "$ofile".elf "$ofile"
427fi
428
429# post-processing needed for some platforms
430case "$platform" in
431pseries|chrp|maple)
432 $objbin/addnote "$ofile"
433 ;;
434coff)
435 ${CROSS}objcopy -O aixcoff-rs6000 --set-start "$entry" "$ofile"
436 $objbin/hack-coff "$ofile"
437 ;;
438cuboot*)
439 gzip -n -f -9 "$ofile"
440 ${MKIMAGE} -A ppc -O linux -T kernel -C gzip -a "$base" -e "$entry" \
441 $uboot_version -d "$ofile".gz "$ofile"
442 ;;
443treeboot*)
444 mv "$ofile" "$ofile.elf"
445 $objbin/mktree "$ofile.elf" "$ofile" "$base" "$entry"
446 if [ -z "$cacheit" ]; then
447 rm -f "$ofile.elf"
448 fi
449 exit 0
450 ;;
451ps3)
452 # The ps3's loader supports loading a gzipped binary image from flash
453 # rom to ram addr zero. The loader then enters the system reset
454 # vector at addr 0x100. A bootwrapper overlay is used to arrange for
455 # a binary image of the kernel to be at addr zero, and yet have a
456 # suitable bootwrapper entry at 0x100. To construct the final rom
457 # image 512 bytes from offset 0x100 is copied to the bootwrapper
458 # place holder at symbol __system_reset_kernel. The 512 bytes of the
459 # bootwrapper entry code at symbol __system_reset_overlay is then
460 # copied to offset 0x100. At runtime the bootwrapper program copies
461 # the data at __system_reset_kernel back to addr 0x100.
462
463 system_reset_overlay=0x`${CROSS}nm "$ofile" \
464 | grep ' __system_reset_overlay$' \
465 | cut -d' ' -f1`
466 system_reset_overlay=`printf "%d" $system_reset_overlay`
467 system_reset_kernel=0x`${CROSS}nm "$ofile" \
468 | grep ' __system_reset_kernel$' \
469 | cut -d' ' -f1`
470 system_reset_kernel=`printf "%d" $system_reset_kernel`
471 overlay_dest="256"
472 overlay_size="512"
473
474 ${CROSS}objcopy -O binary "$ofile" "$ofile.bin"
475
476 run_cmd dd if="$ofile.bin" of="$ofile.bin" conv=notrunc \
477 skip=$overlay_dest seek=$system_reset_kernel \
478 count=$overlay_size bs=1
479
480 run_cmd dd if="$ofile.bin" of="$ofile.bin" conv=notrunc \
481 skip=$system_reset_overlay seek=$overlay_dest \
482 count=$overlay_size bs=1
483
484 odir="$(dirname "$ofile.bin")"
485 rm -f "$odir/otheros.bld"
486 gzip -n --force -9 --stdout "$ofile.bin" > "$odir/otheros.bld"
487 ;;
488esac